package com.steerinfo.baseinfo.meterbasematterunit.controller;

import com.steerinfo.baseinfo.meterbasecustomersupplier.model.MeterBaseCustomerSupplier;
import com.steerinfo.baseinfo.meterbasematterinfo.model.MeterBaseMatterInfo;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasematterunit.model.MeterBaseMatterUnit;
import com.steerinfo.baseinfo.meterbasematterunit.service.IMeterBaseMatterUnitService;
import com.steerinfo.util.PublicMethod;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import oracle.jdbc.proxy.annotation.Post;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.apache.shiro.crypto.hash.Hash;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MeterBaseMatterUnit RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2023-03-29 03:00
 * 类描述
 * 修订历史：
 * 日期：2023-03-29
 * 作者：generator
 * 参考：
 * 描述：MeterBaseMatterUnit RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasematterunits")
public class MeterBaseMatterUnitController extends BaseRESTfulController {

    @Autowired
    IMeterBaseMatterUnitService meterBaseMatterUnitService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterunit:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseMatterUnit> list = meterBaseMatterUnitService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterunit:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseMatterUnit> list = meterBaseMatterUnitService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="创建", notes="根据MeterBaseMatterUnit对象创建")
    @ApiImplicitParam(name = "meterBaseMatterUnit", value = "详细实体meterBaseMatterUnit", required = true, dataType = "MeterBaseMatterUnit")
    //@RequiresPermissions("meterbasematterunit:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseMatterUnit model){
        MeterBaseMatterUnit meterBaseMatterUnit = meterBaseMatterUnitService.add(model);
        return success(meterBaseMatterUnit);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterunit:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseMatterUnit meterBaseMatterUnit = meterBaseMatterUnitService.getById(id);
        return success(meterBaseMatterUnit);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseMatterUnit信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseMatterUnit", value = "详细实体meterBaseMatterUnit", required = true, dataType = "MeterBaseMatterUnit")
    })
    //@RequiresPermissions("meterbasematterunit:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseMatterUnit model){
        model.setId(id);
        MeterBaseMatterUnit meterBaseMatterUnit = meterBaseMatterUnitService.modify(model);
        return success(meterBaseMatterUnit);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterunit:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseMatterUnitService.delete(ids);
    	}
      return success();
    }

    //获取物料
    @ApiOperation(value="获取物料", notes="")
    @ApiImplicitParam(paramType = "String", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterunit:delete")
    @GetMapping(value = "/getMatterInfo")//String
    public RESTfulResult getMatterInfo(@RequestBody(required = false) HashMap map){
        List<MeterBaseMatterInfo> matterInfo = meterBaseMatterUnitService.getMatterInfo(map);
        return success(matterInfo);
    }

    //获取收发货单位
    @ApiOperation(value="获取物料", notes="")
    @ApiImplicitParam(paramType = "String", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterunit:delete")
    @GetMapping(value = "/getCustomerSupplier")//String
    public RESTfulResult getCustomerSupplier(@RequestBody(required = false) HashMap map){
        List<MeterBaseCustomerSupplier> matterInfo = meterBaseMatterUnitService.getCustomerSupplier(map);
        return success(matterInfo);
    }

    @ApiOperation(value="创建", notes="根据MeterBaseMatterUnit对象创建")
    @ApiImplicitParam(name = "meterBaseMatterUnit", value = "详细实体meterBaseMatterUnit", required = true, dataType = "MeterBaseMatterUnit")
    //@RequiresPermissions("meterbasematterunit:create")
    @PostMapping(value = "addMatterUnit")
    public RESTfulResult addMatterUnit(@RequestBody MeterBaseMatterUnit model){
        try {
            String id = PublicMethod.IdCreate(2);
            model.setId(id);
            MeterBaseMatterUnit meterBaseMatterUnit = meterBaseMatterUnitService.add(model);
            return success(meterBaseMatterUnit);
        }catch (Exception e){
            e.printStackTrace();
            throw e;
        }
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterunit:delete")
    @PostMapping(value = "deleteMatterUnit/{id}")//String
    public RESTfulResult deleteMatterUnit(@PathVariable String id){
        List<String> list = Arrays.asList(id.split(","));
        if(ListUtils.isNotEmpty(list)) {
            List<String> ids = ListUtils.convertList(list);
            meterBaseMatterUnitService.delete(ids);
        }
        return success();
    }
}
